OSDN Git Service

PR testsuite/46860
[pf3gnuchains/gcc-fork.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010
8 # Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License.  A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60     if [ -z "$silent" ]; then
61         echo "$@"
62     fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies.  Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 # And then, language-specific files
84 gcc/cp/cfns.h: gcc/cp/cfns.gperf
85 gcc/java/keyword.h: gcc/java/keyword.gperf
86 # testsuite
87 # Without this, _Pragma3.c can have a false negative.
88 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
89 # Similarly, without this, you will see:
90 # direct2s.c:35: warning: current file is older than direct2.c
91 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
92 # lto-plugin
93 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
94 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
95 # And libraries, at last
96 libbanshee/configure: libbanshee/configure.ac
97 libmudflap/configure: libmudflap/configure.ac
98 libobjc/configure: libobjc/configure.ac
99 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
100 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
101 zlib/configure: zlib/configure.ac zlib/aclocal.m4
102 fastjar/aclocal.m4: fastjar/configure.ac
103 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
104 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
105 boehm-gc/aclocal.m4: boehm-gc/configure.ac
106 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
107 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
108 libada/configure: libada/configure.ac
109 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
110 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
111 libffi/configure: libffi/configure.ac libffi/aclocal.m4
112 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
113 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
114 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
115 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
116 libjava/aclocal.m4: libjava/configure.ac
117 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
118 libjava/configure: libjava/configure.ac libjava/aclocal.m4
119 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
120 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
121 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
122 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
123 libcpp/aclocal.m4: libcpp/configure.ac
124 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
125 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
126 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
127 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
128 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
129 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
130 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
131 # Top level
132 Makefile.in: Makefile.tpl Makefile.def
133 configure: configure.ac config/acx.m4
134 EOF
135 }
136
137
138 # This function touches generated files such that the ``end'' user does
139 # not have to rebuild them.
140 touch_files () {
141     rm -f Makefile.$$
142     echo 'all: \' > Makefile.$$
143     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
144     echo '; @true' >> Makefile.$$
145     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
146     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
147     echo ':' >> Makefile.$$
148     echo '      @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
149     echo '      echo Touching $@...; \' >> Makefile.$$
150     chat '      echo Touching $@... 1>&2; \' >> Makefile.$$
151     echo '      touch $@' >> Makefile.$$
152     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
153
154     # We would have to explicitly shut off the "Entering... Leaving..."
155     # messages through "--no-print-directory" to handle the case when
156     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
157     # Makefile, not just make).  Passing only "-s" doesn't help then,
158     # because make has helpfully added "-w" to MAKEFLAGS automatically.
159     # Unfortunately we do not require GNU make other than for building
160     # and testing, so let's just grep known text explicitly echoed by
161     # the rule.
162     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
163       sleep 1
164     done 2>&1
165     rm -f Makefile.$$
166 }
167
168
169 # Whenever we update the tree or install a patch, we may be modifying
170 # this script.  By re-execing it, we ensure that the appropriate
171 # dependencies and rules will be used.
172 touch_files_reexec () {
173     chat "Adjusting file timestamps"
174     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
175 }
176
177 # This functions applies a patch to an existing tree.
178 apply_patch () {
179     if [ -f "$1" ]; then
180         echo "Applying patch file $1"
181         case $1 in
182         *gz)
183             gzip -d -c "$1" | patch -p1 ;;
184         *bz2)
185             bzip2 -d -c "$1" | patch -p1 ;;
186         *)
187             patch -p1 < "$1";;
188         esac
189     fi
190     touch_files_reexec
191 }
192
193 # Check whether this indeed looks like a local tree.
194 if [ ! -f gcc/version.c ]; then
195     echo "This does not seem to be a GCC tree!"
196     exit
197 fi
198
199 case "$1" in
200 --silent)
201     silent=t
202     shift
203     ;;
204 esac
205
206 case "$1" in
207 # First of all, check whether we are going to process a patch.
208 --patch)
209     if test "$#" != 2; then
210         echo "$1" expects only one argument >&2
211         exit 1
212     fi
213     apply_patch "${2}"
214     exit $?
215     ;;
216
217 --touch)
218     if test "$#" != 1; then
219         echo "$1" does not expect any argument >&2
220         exit 1
221     fi
222     touch_files
223     exit $?
224     ;;
225
226 --list)
227     if test "$#" != 1; then
228         echo "$1" does not expect any argument >&2
229         exit 1
230     fi
231     files_and_dependencies | sed 's/ /: /'
232     exit $?
233     ;;
234
235 --help)
236     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
237 \
238
239 p
240 }' \
241         -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
242     exit $?
243     ;;
244
245 esac
246
247 # Check for known version control systems.
248 if [ -d .git ]; then
249     GCC_GIT=${GCC_GIT-${GIT-git}}
250     vcs_type="git"
251 elif [ -d .hg ]; then
252     GCC_HG=${GCC_HG-${HG-hg}}
253     vcs_type="hg"
254 elif [ -d .svn ]; then
255     GCC_SVN=${GCC_SVN-${SVN-svn}}
256     vcs_type="svn"
257 else
258     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
259     exit
260 fi
261
262 # Check command-line options
263 if [ x"${1}"x = x"--nostdflags"x ]; then
264     shift
265 else
266     set -- $UPDATE_OPTIONS ${1+"$@"}
267 fi
268
269 case $vcs_type in
270     git)
271         chat "Updating GIT tree"
272
273         $GCC_GIT diff --quiet --exit-code HEAD
274         if [ $? -ne 0 ]; then
275             echo "Attempting to update a dirty git tree!" >&2
276             echo "Commit or stash your changes first and retry." >&2
277             exit 1
278         fi
279
280         $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
281         if [ $? -ne 0 ]; then
282             (touch_files_reexec)
283             echo "git pull of full tree failed." >&2
284             exit 1
285         fi
286
287         revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
288         branch=`$GCC_GIT name-rev --name-only HEAD || :`
289         ;;    
290
291     hg)
292         chat "Updating HG tree"
293
294         # Add -q so untracked files aren't listed.
295         if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
296             echo "Attempting to update a dirty hg tree!" >&2
297             echo "Commit or revert your changes first and retry." >&2
298             exit 1
299         fi
300
301         # Check for mq extension.  mq patches must be popped so tip has
302         # been converted from the SVN tree.
303         if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
304             # FIXME: Perhaps pop queue instead?  We could do that since we
305             # know the tree is clean.
306             echo "Attempting to update hg tree with mq patches applied!" >&2
307             echo "Pop your patches first and retry." >&2
308             exit 1
309         fi
310
311         # Update tree, but make sure to only pull the default branch.
312         # Otherwise all branches in the upstream repo are added, even if
313         # only a single one has been cloned.
314         $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
315         if [ $? -ne 0 ]; then
316             (touch_files_reexec)
317             echo "hg pull of full tree failed." >&2
318             exit 1
319         fi
320
321         # Update tree.  Needs to be done separately from pull so
322         # gcc_update -rREV works.
323         $GCC_HG update ${silent+-q} ${1+"$@"}
324         if [ $? -ne 0 ]; then
325             (touch_files_reexec)
326             echo "hg update of full tree failed." >&2
327             exit 1
328         fi
329
330         # Extract SVN revision corresponding to parents, as stored by
331         # hg convert.  Before hg 1.4.3, there's no template keyword
332         # corresponding to the extra: tag, so need to use hg log --debug
333         # to extract the info.
334         parents=`$GCC_HG parents --template '{rev}'`
335         revision=`$GCC_HG log --debug -r$parents | \
336             sed -ne "/^extra:.*convert_revision=svn:/ {
337                 s%^.*@%%
338                 p
339             }"`
340         branch=`$GCC_HG branch`
341         # trunk in SVN parlance shows up as default branch in hg.
342         [ x$branch = x"default" ] && branch="trunk"
343         ;;
344
345     svn)
346         chat "Updating SVN tree"
347
348         $GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
349         if [ $? -ne 0 ]; then
350             (touch_files_reexec)
351             echo "SVN update of full tree failed." >&2
352             exit 1
353         fi
354
355         revision=`svn info | awk '/Revision:/ { print $2 }'`
356         branch=`svn info | sed -ne "/URL:/ {
357             s,.*/trunk,trunk,
358             s,.*/branches/,,
359             s,.*/tags/,,
360             p
361         }"`
362         ;;
363 esac
364
365 rm -f LAST_UPDATED gcc/REVISION
366 {
367     date
368     echo "`TZ=UTC date` (revision $revision)"
369 } > LAST_UPDATED
370 echo "[$branch revision $revision]" > gcc/REVISION
371
372 touch_files_reexec